exec("./Item_NameWand.cs");
if(isFile("Add-Ons/System_ReturnToBlockland/server.cs"))
{
	if(!$NameWand::PrefsSet)
	{
		if(!$RTB::RTBR_ServerControl_Hook)
		{
			exec("Add-Ons/System_ReturnToBlockland/RTBR_ServerControl_Hook.cs");
		}
		RTB_registerPref("Admin Only", "Name Wand", "NameWand::Pref::AdminOnly", "bool", "Tool_NameWand", 0, 0, 0);
		RTB_registerPref("Trust Required", "Name Wand", "NameWand::Pref::TrustLevel", "list None 0 Build 1 Full 2 You 3", "Tool_NameWand", 3, 0, 0);
		$NameWand::PrefsSet = true;
	}
}
else
{
	// If you do not have RTB you can change the preferences here
$Namewand::Pref::AdminOnly  = 0; //Admin Only (Yes = 1, No = 0)
$Namewand::Pref::TrustLevel = 3; //Trust Level (None = 0, Build = 1, Full = 2, Self = 3)
}


function namewandProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal){
   if(%col.getclassname()$=fxDTSbrick){
   if($Namewand::Pref::AdminOnly == 1 && !%obj.client.isAdmin){
   %obj.client.centerPrint("\c6The Name Wand is set as admin only.",3);
   return;
   }
   if(%obj.client.namewanden $= "disabled"){
   %obj.client.centerPrint("\c6The Name Wand is currently disabled. Say \c3/Namewand Enable \c6to enable.",3);
   return;
   }
  if(getTrustLevel(%obj, %col) < $Namewand::Pref::TrustLevel){
  %obj.client.centerPrint("<color:FF8888>" @ %col.getGroup().name @ "<color:FF0000> does not trust you enough to do that.",3);
  return;
  }
  %name = %col.getName();
  switch$(%obj.client.namewandmode){
  
  case "up":
  dobrickup(%name, %col, %obj.client);
  break;
  
  case "down":
  dobrickdown(%name, %col, %obj.client);
  break;
  
  default:
  dobrickup(%name, %col, %obj.client);
  break;
  }
  if(%col.getName() $= ""){
  %obj.client.centerPrint("\c6Bricks now have no name.",3);
  }else{
  %obj.client.centerPrint("\c6Bricks have been renamed to \c3" @ getSubStr(%col.getName(), 1, strlen(%col.getName()) - 1) @ "\c6.",3);
  }
}
}


function serverCmdNamewand(%client, %mode)
	{
	%input = strLwr(%mode);
	if(%input $= "disable"){
	%client.centerPrint("\c6The Name Wand has been disabled. Say \c3/Namewand Enable \c6to re-enable.",4);
	%client.namewanden = "disabled";
	}else if(%input $= "enable"){
	%client.centerPrint("\c6The Name Wand has been enabled. Say \c3/Namewand Disable \c6to disable.",4);
	%client.namewanden = "enabled";
	}else if(%input $= "down"){
	%client.centerPrint("\c6The Name Wand is now set to name bricks from top-down.",4);
	%client.namewandmode = "down";
	}else if(%input $= "up"){
	%client.centerPrint("\c6The Name Wand is now set to name bricks from bottom-up.",4);
	%client.namewandmode = "up";
	}else{
		%player = %client.player;
		if(isObject(%player))
		{
			%player.updateArm("namewandImage");
			%player.mountImage("namewandImage", 0);
		}
	}
	}

function dobrickup(%name, %col, %client)
{
for(%i = 0; %i < %col.getNumUpBricks(); %i++)
			{
				%brick = %col.getUpBrick(%i);
				if(!%beenNamed[%brick])
				{
					dobrickup(%name, %brick);
					if(%name $= "")
					%brick.setName("");
					else
					%brick.setNTObjectName(%name);
					%beenNamed[%brick] = 1;
				}
			}
}

function dobrickdown(%name, %col)
{
for(%i = 0; %i < %col.getNumDownBricks(); %i++)
			{
				%brick = %col.getDownBrick(%i);
				if(!%beenNamed[%brick])
				{
					dobrickdown(%name, %brick);
					if(%name $= "")
					%brick.setName("");
					else
					%brick.setNTObjectName(%name);
					%beenNamed[%brick] = 1;
				}
			}
}